package be.jeffcheasey88.todo.model;

import java.util.List;

import be.jeffcheasey88.todo.User;

public interface Repository {
	
	Result<String> login(String username, String password);
	
	Result<List<String>> getProjects(UserWorker user);
	
	Result<Project> createProject(UserWorker user, String name);
	
	Result<Project> removeProject(UserWorker user, String name);
	
	Result<Project> getProject(UserWorker user, String name);
	
	Result<Boolean> renameProject(UserWorker user, String lastname, String updatedname);
	
	Result<Boolean> manageUsers(UserWorker user, String project, List<String> users);
	
	Result<List<String>> getUsers();
	
	Result<List<String>> getUsers(String project);
	
	
}
