package be.jeffcheasey88.todo.model;

import java.util.ArrayList;
import java.util.List;

import dev.peerat.framework.utils.json.JsonArray;
import dev.peerat.framework.utils.json.JsonMap;

public class Task implements JsonSerializable{
	
	private List<String> users;
	private String name;
	private TaskModifier modifier;
	
	public Task(){
		this.users = new ArrayList<>();
		this.modifier = new TaskModifier();
	}
	
	public Task(JsonMap json){
		this();
		for(Object user : json.<JsonArray>get("users").toList()){
			this.users.add((String) user);
		}
		this.name = json.get("name");
		this.modifier = new TaskModifier(json.get("modifier"));
	}
	
	@Override
	public void serialize(JsonMap json){
		JsonArray jusers = new JsonArray();
		for(String user : users) jusers.add(user);
		json.set("users", jusers);
		json.set("name", this.name);
		JsonMap jmodifier =  new JsonMap();
		this.modifier.serialize(jmodifier);
		json.set("modifier", jmodifier);
	}
	
	public List<String> getUsers(){
		return this.users;
	}
	
	public String getName(){
		return this.name;
	}
	
	public void setName(String name){
		this.name = name;
	}

	public TaskModifier getModifier(){
		return this.modifier;
	}
}
