package be.jeffcheasey88.todo.model;

import java.util.ArrayList;
import java.util.List;

import dev.peerat.framework.utils.json.JsonArray;
import dev.peerat.framework.utils.json.JsonMap;

public class TaskContainer extends Task implements JsonSerializable{
	
	private List<Task> tasks;
	
	public TaskContainer(){
		this.tasks = new ArrayList<>();
	}
	
	public TaskContainer(JsonMap json){
		this();
		for(Object task : json.<JsonArray>get("tasks").toList()){
			tasks.add((Task) task);
		}
	}

	@Override
	public void serialize(JsonMap json){
		JsonArray jTasks = new JsonArray();
		for(Task task : tasks){
			JsonMap jtask = new JsonMap();
			task.serialize(jtask);
			jTasks.add(jtask);
		}
		json.set("tasks", jTasks);
	}
	
	public List<Task> getTasks(){
		return this.tasks;
	}
}
