package be.jeffcheasey88.todo.routes.users;

import java.util.regex.Matcher;

import be.jeffcheasey88.todo.User;
import be.jeffcheasey88.todo.model.Repository;
import be.jeffcheasey88.todo.model.Result;
import dev.peerat.framework.Context;
import dev.peerat.framework.HttpReader;
import dev.peerat.framework.HttpWriter;
import dev.peerat.framework.RequestType;
import dev.peerat.framework.Response;
import dev.peerat.framework.Route;
import dev.peerat.framework.utils.json.JsonMap;

public class Login implements Response{
	
	private Repository repo;
	
	public Login(Repository repo){
		this.repo = repo;
	}

	@Route(path = "^/login$", type = RequestType.POST)
	public void exec(Matcher matcher, Context context, HttpReader reader, HttpWriter writer) throws Exception {
		if (context.isLogged()){
			context.response(403);
			return;
		}
		
		JsonMap json = reader.readJson();
		Result<String> result = repo.login(json.get("username"), json.get("password"));
		if(result.success()){
			context.response(200,
					"Access-Control-Allow-Origin: *",
					"Access-Control-Expose-Headers: Authorization",
					"Authorization: Bearer " + result.getElement());
		}else{
			result.send(context, writer);
		}
	}

}
